--- CDC.cpp.org	2014-01-31 10:45:47.547082817 -0500
+++ CDC.cpp	2014-01-31 10:53:09.331100779 -0500
@@ -76,6 +76,14 @@
 	return USB_SendControl(TRANSFER_PGM,&_cdcInterface,sizeof(_cdcInterface));
 }
 
+void WEAK lineCodingEvent(long baud, byte databits, byte parity, byte charFormat)
+{
+}
+
+void WEAK lineStateEvent(byte linestate)
+{
+}
+
 bool WEAK CDC_Setup(Setup& setup)
 {
 	u8 r = setup.bRequest;
@@ -95,6 +103,10 @@
 		if (CDC_SET_LINE_CODING == r)
 		{
 			USB_RecvControl((void*)&_usbLineInfo,7);
+			lineCodingEvent(_usbLineInfo.dwDTERate,
+					_usbLineInfo.bDataBits,
+					_usbLineInfo.bParityType,
+					_usbLineInfo.bCharFormat);
 			return true;
 		}
 
@@ -102,6 +114,8 @@
 		{
 			_usbLineInfo.lineState = setup.wValueL;
 
+			lineStateEvent(_usbLineInfo.lineState);
+
 			// auto-reset into the bootloader is triggered when the port, already 
 			// open at 1200 bps, is closed.  this is the signal to start the watchdog
 			// with a relatively long period so it can finish housekeeping tasks
